package org.dromara.art.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.art.domain.bo.ArtSchoolEnrollCodeBo;
import org.dromara.art.domain.vo.ArtSchoolEnrollCodeVo;
import org.dromara.art.domain.ArtSchoolEnrollCode;
import org.dromara.art.mapper.ArtSchoolEnrollCodeMapper;
import org.dromara.art.service.IArtSchoolEnrollCodeService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 学校招生代码Service业务层处理
 *
 * @author ZhouWenTao
 * @date 2026-02-19
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ArtSchoolEnrollCodeServiceImpl implements IArtSchoolEnrollCodeService {

    private final ArtSchoolEnrollCodeMapper baseMapper;

    /**
     * 查询学校招生代码
     *
     * @param id 主键
     * @return 学校招生代码
     */
    @Override
    public ArtSchoolEnrollCodeVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询学校招生代码列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 学校招生代码分页列表
     */
    @Override
    public TableDataInfo<ArtSchoolEnrollCodeVo> queryPageList(ArtSchoolEnrollCodeBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ArtSchoolEnrollCode> lqw = buildQueryWrapper(bo);
        Page<ArtSchoolEnrollCodeVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的学校招生代码列表
     *
     * @param bo 查询条件
     * @return 学校招生代码列表
     */
    @Override
    public List<ArtSchoolEnrollCodeVo> queryList(ArtSchoolEnrollCodeBo bo) {
        LambdaQueryWrapper<ArtSchoolEnrollCode> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ArtSchoolEnrollCode> buildQueryWrapper(ArtSchoolEnrollCodeBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ArtSchoolEnrollCode> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ArtSchoolEnrollCode::getId);
        lqw.eq(bo.getSchoolId() != null, ArtSchoolEnrollCode::getSchoolId, bo.getSchoolId());
        lqw.eq(StringUtils.isNotBlank(bo.getEnrollCode()), ArtSchoolEnrollCode::getEnrollCode, bo.getEnrollCode());
        return lqw;
    }

    /**
     * 新增学校招生代码
     *
     * @param bo 学校招生代码
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ArtSchoolEnrollCodeBo bo) {
        ArtSchoolEnrollCode add = MapstructUtils.convert(bo, ArtSchoolEnrollCode.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改学校招生代码
     *
     * @param bo 学校招生代码
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ArtSchoolEnrollCodeBo bo) {
        ArtSchoolEnrollCode update = MapstructUtils.convert(bo, ArtSchoolEnrollCode.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ArtSchoolEnrollCode entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除学校招生代码信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
